"use strict";
var RmqBroadCastModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.RmqBroadCastModule = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const rmq_service_1 = require("./rmq.service");
const rmq_broadcast_module_definition_1 = require("./rmq-broadcast.module-definition");
const nestjs_rabbitmq_1 = require("@golevelup/nestjs-rabbitmq");
let RmqBroadCastModule = RmqBroadCastModule_1 = class RmqBroadCastModule extends rmq_broadcast_module_definition_1.RmqBroadcastModuleDefinition.ConfigurableModuleClass {
    // static forRoot(options: { config: { uri: string } }): DynamicModule {
    //   return {
    //     module: RmqBroadCastModule,
    //     imports: [
    //       RabbitMQModule.forRoot(RabbitMQModule, {
    //         exchanges: [
    //           {
    //             name: 'agent.exchange',
    //             type: 'fanout',
    //           },
    //           {
    //             name: 'call.exchange',
    //             type: 'fanout',
    //           },
    //         ],
    //         uri: options.config.uri,
    //         connectionInitOptions: { wait: false },
    //         enableControllerDiscovery: true,
    //         channels: {
    //           'socket-channel': {
    //             prefetchCount: 15,
    //             default: true,
    //           },
    //         },
    //       }),
    //     ],
    //     exports: [
    //       RabbitMQModule,
    //       RmqBroadCastModule,
    //       AmqpConnection,
    //       AmqpConnectionManager,
    //     ],
    //   };
    // }
    // static forRootAsync(
    //   options: typeof RmqBroadcastModuleDefinition.ASYNC_OPTIONS_TYPE,
    // ): DynamicModule {
    //   return {
    //     module: RmqBroadCastModule,
    //     imports: [
    //       ...(options.imports || []),
    //       RabbitMQModule.forRootAsync(RabbitMQModule,
    //           {
    //               useFactory: async (...args) => {
    //                   const opt = await options.useFactory!(...args);
    //                   return {
    //                       exchanges: [
    //                           {
    //                               name: 'agent.exchange',
    //                               type: 'fanout',
    //                           },
    //                           {
    //                             name: 'call.exchange',
    //                             type: 'fanout',
    //                           },
    //                       ],
    //                       uri: opt.config?.uri || '',
    //                       connectionInitOptions: { wait: false },
    //                       enableControllerDiscovery: true,
    //                       channels: {
    //                           'socket-channel': {
    //                               prefetchCount: 15,
    //                               default: true,
    //                           },
    //                       },
    //                   };
    //               },
    //               inject: (options.inject as any) || [],
    //               imports: options.imports || [],
    //           }
    //       ),
    //     ],
    //     exports: [RabbitMQModule, RmqBroadCastModule],
    //   };
    // }
    static register(config) {
        console.log('config from core ============== ', config);
        return {
            module: RmqBroadCastModule_1,
            imports: [
                nestjs_rabbitmq_1.RabbitMQModule.forRoot(nestjs_rabbitmq_1.RabbitMQModule, {
                    exchanges: [
                        {
                            name: 'agent.exchange',
                            type: 'fanout',
                        },
                        {
                            name: 'call.exchange',
                            type: 'fanout',
                        },
                    ],
                    uri: config.rmqURI,
                    connectionInitOptions: { wait: false },
                    enableControllerDiscovery: false,
                    channels: {
                        'socket-channel': {
                            prefetchCount: 15,
                            default: true,
                        },
                    },
                }),
            ],
            exports: [nestjs_rabbitmq_1.RabbitMQModule],
        };
    }
};
exports.RmqBroadCastModule = RmqBroadCastModule;
exports.RmqBroadCastModule = RmqBroadCastModule = RmqBroadCastModule_1 = tslib_1.__decorate([
    (0, common_1.Module)({
        providers: [rmq_service_1.RmqService],
        exports: [],
    })
], RmqBroadCastModule);
